#ifndef __complex__
#define __complex__

template <class T>
class Complex {
	public:
		Complex(){ memset(&m_r,0,sizeof(T)),memset(&m_i,0,sizeof(T));}
		Complex(T r,T i):m_r(r),m_i(i) {}

		void operator=(T r){ m_r=r; }

		friend T          real(Complex<T> c) { return c.m_r; }
		friend T          imag(Complex<T> c) { return c.m_i; }
		friend Complex<T> conj(Complex<T> c) { return Complex<T>(c.m_r,-c.m_i); }

		Complex<T> operator-(Complex<T>& c2){
			return Complex<T>(m_r-c2.m_r,m_i-c2.m_i);
		}

		Complex<T> operator+(Complex<T>& c2){
			return Complex<T>(m_r+c2.m_r,m_i+c2.m_i);
		}

		void operator+=(const Complex<T>& c2){
			m_r+=c2.m_r;
			m_i+=c2.m_i;
		}
		void operator-=(const Complex<T>& c2){
			m_r-=c2.m_r;
			m_i-=c2.m_i;
		}

		Complex<T> operator*(Complex<T> c2){
			return Complex<T>(m_r*c2.m_r-m_i*c2.m_i,m_r*c2.m_i+m_i*c2.m_r);
		}

		void operator*=(Complex<T> c2){
			T oldm_r=m_r;
			T oldm_i=m_i;
			m_r=oldm_r*c2.m_r-oldm_i*c2.m_i;
			m_i=oldm_r*c2.m_i+oldm_i*c2.m_r;
		}

		friend Complex<T> operator*(T lambda,Complex<T> c){
			return Complex<T>(lambda*c.m_r,lambda*c.m_i);
		}

		friend Complex<T> operator*(Complex<T> c,T lambda){
			return Complex<T>(lambda*c.m_r,lambda*c.m_i);
		}
/*
		friend ostream& operator<<(ostream& o,Complex<T> c){ return o<<"["<<c.m_r<<","<<c.m_i<<"]"; }
		*/
	private:
		T m_r;
		T m_i;
};

#endif
