#include "ExpansionCoefficients.hpp"


ExpansionCoefficients::ExpansionCoefficients(Vec3f _center, int _p){
	center=_center;
    p=_p;
    csms=new CplxSourceMatrices**[p+1];
    for(int n=0;n<=p;n++){
		csms[n]=new CplxSourceMatrices*[n/2+1];
		for(int j=0;j<=n/2;j++){
			csms[n][j]=new CplxSourceMatrices[2*(n-2*j)+1];
			csms[n][j]=&csms[n][j][(n-2*j)];
		}
	}
}

ExpansionCoefficients::~ExpansionCoefficients(){
  /*
   for(int n=0;n<=p;n++){
		for(int j=0;j<=n/2;j++){
			csms[n][j]=&csms[n][j][-n+2*j+1];
			delete[] csms[n][j];
		}
		delete[] csms[n];
	}	
    
  delete[] csms;
  */
}

void ExpansionCoefficients::reset(){
	for(int n=0;n<=p;n++){
		for(int j=0;j<=n/2;j++){
			for(int m=-n+2*j;m<=n-2*j;m++){
					memset(&csms[n][j][m],0,sizeof(CplxSourceMatrices));
			}
		}
	}
}
