#ifndef __expansioncoefficients__
#define __expansioncoefficients__


#include "MatrixSets.hpp"

class ExpansionCoefficients {
	
public:
	
	ExpansionCoefficients(Vec3f _center, int _p);
	~ExpansionCoefficients();
	
	void operator+=(ExpansionCoefficients m2){
		for(int n=0;n<=p;n++){
			for(int j=0;j<=n/2;j++){
				for(int m=-n+2*j;m<=n-2*j;m++){
					csms[n][j][m]+=m2.csms[n][j][m];
				}
			}
		}
	}  
	
	void reset();

	inline CplxSourceMatrices& operator()(int n,int j,int m){
		return csms[n][j][m];
	} 
	
	inline const CplxSourceMatrices& operator()(int n,int j,int m) const {
		return csms[n][j][m];
	}
	
	CplxSourceMatrices ***csms;
	Vec3f center;
	int p;
	
};

class MultipoleExpansionCoefficients;
class LocalExpansionCoefficients;

#endif
