#ifndef __mathfuncs__
#define __mathfuncs__

#include "src/Radical.hpp"
#include "gsl/gsl_sf_legendre.h"
#include "gsl/gsl_sf_coupling.h"
#include "SphericalHarmonics.hpp"

extern int PMAX;
extern float **e;
extern float *******jstore;
extern Cplxf** Ynm;

//#define M_PI 3.1415926535898

void initMath(int p);
void initSphHrm();
void ecache(int p);
void jcache(int p);
void fillYnmCache(float theta,float phi,int p);

Vec3f sph(const Vec3f& v);
float fact(float n);
float Jcalc(int l1,int m1,int l2,int s,int N,int M,int L);
float poc(float a,float s);
float J(int l1,int m1,int l2,int s,int N,int M,int L);
Cplxf __Ynm(int n,int m,float theta, float phi);

/*****************************************
 Values for Gaussian Integration - PHBPHD
****************************************/

typedef struct gaussTriangleWeights {
  int degree,numberOfNodes;
  double u[20],v[20],w[20];
} gaussTriangleWeights;

extern gaussTriangleWeights gtrw[10];
void initIntegration();

#endif
