#ifndef __multipoleexpasioncoefficients__
#define __multipoleexpasioncoefficients__

#include "src/Radical.hpp"
#include "src/PatchPoint.hpp"
#include "ExpansionCoefficients.hpp"
#include "MathFuncs.hpp"

class MultipoleExpansionCoefficients : public ExpansionCoefficients {
 public:
  MultipoleExpansionCoefficients(Vec3f center,int p): ExpansionCoefficients(center,p) {}
  MultipoleExpansionCoefficients(Vec3f r,Vec3f n, float radiosity, Vec3f center, int p);  
  MultipoleExpansionCoefficients translateTo(Vec3f newCenter);
  LocalExpansionCoefficients     getLocalCoefficientsFor(Vec3f newCenter);
  void addPatchPointMultipole(PatchPoint* pp,int channel);
  void addTranslatedMultipole(MultipoleExpansionCoefficients* mecs);
  float evaluateAtPoint(Vec3f r,Vec3f n, float rho);
};

#endif
