#include "MathFuncs.hpp"
#include "gsl/gsl_sf_legendre.h"


Cplxf** Ynm;
double* gslSphPlmResult;

void initSphHrm(){
	Ynm=new Cplxf*[2*PMAX+1];
	for(int i=0;i<=2*PMAX;i++){
		Ynm[i]=new Cplxf[2*i+1];
		Ynm[i]=&Ynm[i][i];
	}
	gslSphPlmResult=new double[2*PMAX+1];
}

void fillYnmCache(float theta,float phi,int p){
	float costheta=cos(theta);
	int negMmult;
  	float sinmphi;
   	float cosmphi;
	for(int m=0;m<=p;m++){
	  negMmult=(m%2==0?1:-1);
	  sinmphi=sin(m*phi);
	  cosmphi=cos(m*phi);
	  gsl_sf_legendre_sphPlm_array(p,abs(m),costheta,gslSphPlmResult) ;
	  for(int n=m;n<=p;n++){
	    Ynm[n][m]=Cplxf(gslSphPlmResult[n-m]*cosmphi,gslSphPlmResult[n-m]*sinmphi);
	    Ynm[n][-m]=Cplxf(gslSphPlmResult[n-m]*cosmphi*negMmult,-gslSphPlmResult[n-m]*sinmphi*negMmult);
	  }
	}
}	


Cplxf __Ynm(int n,int m,float theta, float phi){
  int hack=(m<0)?(m%2==0?1:-1):1;
  float legTerm=gsl_sf_legendre_sphPlm(n,abs(m),cos(theta));//sqrtf((2*n+1)/(4*3.14159));
  return Cplxf(legTerm*cos(m*phi)*hack,legTerm*sin(m*phi)*hack);
}
