#ifndef __Vec3ft__
#define __Vec3ft__

#include "src/Radical.hpp"
#include "vl/Mat3.h"

class Vec3ft: public Vec3f {
 public:
  inline void operator=(Vec3f v){
    (*this)[0]=v[0];
    (*this)[1]=v[1];
    (*this)[2]=v[2];
    
  }
};

inline Vec3ft operator-(Vec3ft v1,Vec3ft v2){
	Vec3ft v3;
	v3[0]=v1[0]-v2[0];
	v3[1]=v1[1]-v2[1];
	v3[2]=v1[2]-v2[2];
	return v3;
}

inline Vec3ft operator*(float f,Vec3ft v){
	Vec3ft v2; 
	v2[0]=v[0]*f;
	v2[1]=v[1]*f;
	v2[2]=v[2]*f;

	return v2;
}

inline float operator*(Vec3ft v1,Vec3f v2){
  return v1[0]*v2[0]+v1[1]*v2[1]+v1[2]*v2[2];
}

inline Mat3f operator*(Vec3f v1,Vec3ft v2){
  Mat3f m;
  for(int i=0;i<3;i++)
    for(int j=0;j<3;j++)
      m[i][j]=v1[i]*v2[j];
  return m;
}

inline Vec3ft trans(Vec3f v){
  Vec3ft v2;
  v2[0]=v[0];v2[1]=v[1];v2[2]=v[2];
  return v2;
}

#endif
 
