#ifndef __cells__
#define __cells__

#include "PatchPoint.hpp"
#include "PointData.hpp"
#include "math/MultipoleExpansionCoefficients.hpp"
#include "math/LocalExpansionCoefficients.hpp"
#include "math/ExpansionCoefficients.hpp"
#include <fstream>
class Cell {

public:
  MultipoleExpansionCoefficients* mecs;
  LocalExpansionCoefficients* lecs;
  

  Cell(Cell* parent,Vec3f center,float side):
    parent(parent),center(center),side(side) {
    if (parent)
      depth=parent->depth+1;
    else
      depth=0;
    mecs=new MultipoleExpansionCoefficients(center,2);
    lecs=new LocalExpansionCoefficients(center,2);
  }

  Cell* parent;
  void createtree(vector<PatchPoint*>&,int);
  void assgn_weight();
  bool operator==(Cell*);
  bool contains(Vec3f);
  int start, end;
  static int nm;
  vector<int> bit;
  void modify();
  void createlist();
  bool isLeaf() {return children.size()==0; }
  bool isNearNeighbor(Cell* other);
  void pull(int channel);
  Vec3f center;
  float side;
  void push(int,int);
  void tofile(FILE *);
  vector<Cell*> nearCells;
  vector<Cell*> init_nearCells;
  vector<Cell*> farCells;
  vector<Cell*> init_farCells;
  vector<Cell*> multipole;
  vector<Cell*> local;
  vector<PatchPoint*> patchPoints;
  vector<Cell*> children;
  int depth;
  void check_intersect(Vec3f, Vec3f, vector<float>&);
  void copy_pts(vector<PointData*>&);
  void copy_rad();
  void get_info(); //debugging omly !!!
}
  ;
typedef list<Cell*>::iterator CellItr;
typedef vector<Cell*>::iterator CellItrv;
#endif
