#include "Mesh.hpp"

extern Vec3f pointCoord;

Point_Mesh::Point_Mesh(vector<PatchPoint*> &Point_List, unsigned long int mesh_Vertices){
  Vec3f* vertices=new Vec3f[mesh_Vertices];
  Vec3f pMax(-HUGE_VAL,-HUGE_VAL,-HUGE_VAL),pMin(HUGE_VAL,HUGE_VAL,HUGE_VAL);
  side=0;
  unsigned long int i=0;
  for(PPListItr p_itr = Point_List.begin();p_itr!=Point_List.end();p_itr++){
    for(int j=0;j<3;j++){
      vertices[i][j] = (*p_itr)->coords[j];
      pMax[j]=max(vertices[i][j],pMax[j]);
      pMin[j]=min(vertices[i][j],pMin[j]);
      side=max(side,pMax[j]-pMin[j]);
    }
    i++;
  }
  center=(pMax+pMin)/2;
  cout << "Center of Root :: " << center << endl;
  cout << "Side of Root Voxel :: " << side << endl;
  
  for(PPListItr p_itr = Point_List.begin();p_itr!=Point_List.end();p_itr++){
#ifdef DEBUG
    //float px=8.280000,py= 3.243333,pz= 7.333333;
//    float px=13.333333,py=9.375000,pz=8.125000;
//    float px=13.333333,py=9.166667,pz=8.750000;     //2500
//    float px=13.333333,py=9.166667,pz=10.833333;
//    float px=8.280000,py=3.243333, pz=7.333333;
//    float px=0.000000,py=0.833333, pz=9.166667;
//    float px=3.333333,py=1.153333,pz=10.000000;
//    float px=0.000000,py=1.666667,pz=10.833333;
//    float px=0.000000,py=1.250000,pz=8.125000;      //8400
//    float px=0.000000,py=0.833333,pz=7.916667;      //2500
//    float px=13.333333,py=8.125000,pz=9.583333;
//    float px=7.083333,py=0.000000,pz=9.166667;      //2500
//    float px=6.250000,py=0.000000,pz=9.166667;      //2500
//    float px=0.000000,py=0.416667,pz=9.166667;      //2500
#endif


//    float px=0.000000,py=0.416667,pz=9.166667;      //2500
//    float px=0.000000,py=1.666667,pz=9.166667;      //642 points3.842500 2.601667 10.666667
//float px=3.842500,py=2.601667,pz=10.666667;      //3900 points
     float px=3.887500,py=4.525000,pz=10.666667;      //642 points
//      float px=3.486667,py=3.550000,pz=10.666667;      //642 points
    Vec3f v(px,py,pz);
    
    if(len((*p_itr)->coords - v)<=1e-6) {
      cout << (*p_itr)->coords - v << endl;
      (*p_itr)->mark = 1;
      pointCoord = (*p_itr)->coords - center;
    }
    else {
      (*p_itr)->mark = 0;}
    
    for(int j=0;j<3;j++) {
      (*p_itr)->coords[j] = (*p_itr)->coords[j] - center[j]; 
    }
  }
  center=Vec3f(0,0,0);
}
