#ifndef __patchpoint__
#define __patchpoint__

#include "Radical.hpp"
//#include "ReadMesh.hpp"
//#include "ReadMaterial.hpp"

class PatchPoint {
public:
  
  PatchPoint(Vec3f coords,Vec3f normal,Vec3f diffVal,Vec3f emmVal, int assgn, int mark)
    :coords(coords),normal(normal),diffVal(diffVal),emmVal(emmVal), rhoVal(diffVal),assgn(assgn), mark(mark){
    radVal=emmVal; newRadVal = emmVal;
  }
  
  float weight;  
  Vec3f coords;
  Vec3f normal;
  Vec3f diffVal;
  Vec3f radVal;
  Vec3f emmVal;
  Vec3f newRadVal;
  Vec3f rhoVal;
  int assgn;
  int mark; //debugging only
  //friend long int populatePatchPoints(vector<PatchPoint*>& pts, vector<Mesh>& pMesh);
  friend long int createPatchPoints(vector<PatchPoint*>& pts, char *);
  float evaluateDirect(PatchPoint* r2,int channel)
  {
    double r=0;
    if(len(coords-r2->coords)>0.01)
      {
	r = r2->weight*r2->radVal[channel]*rhoVal[channel]*dot(normal,r2->coords-coords)*dot(r2->normal,coords-r2->coords)/(double)(3.14*pow(len(r2->coords-coords),4));
      }
    return((float)r);
  }
};
typedef vector<PatchPoint*>           PPList;
typedef vector<PatchPoint*>::iterator PPListItr; 

#endif
