#ifndef SPLAT
#define SPLAT

#define DOT_THRESHOLD .5

const int	maxResolution = 256;
const int	maxSubpixels = 16;
const float	maxPrefiltersize = 1.0f;	//1.0f

int sizex = 256;
int sizey = 256;
int subpixels = 1;
float prefiltersize = 0.0f;	//1.0f

const float defaultWidth = 512;
const float defaultHeight = 512;
float	pixelScale = defaultWidth/(float)sizex;
float	figsx,figsy;

const int			jitterPatterns = 64;
const int			gausssamples = 256;
Vector2				*prefilterJitter = NULL;
Vector2				*lensJitter = NULL;

const float			F = 2.0f;

const float			prefiltercutoff = 2.0f;	//2.0f

const float			conditionThreshold = 1000.0f;

const char			objectFile[] = {"venus.lwo"};
const int			subdivision = 3;

const float			focus = 10.0f;
const float			aperture = 2.8f;
const float			imagePlane = 1.0f;	//do not change
const float			focalLength = imagePlane*focus/(imagePlane+focus);
const float			lensRadius = focalLength*0.5f/aperture;

bool				rasterization = true;
bool				pointvisualization = false;
bool				reconstructionvisualization = false;


struct Splat
{
	Vector3		m_position;
	Vector3		m_normal;
	Vector4		m_color;
	float		m_size;
};

#endif
