#ifndef __Material__
#define __Material__

#include <string>
#include <fstream>
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <cctype>
#include "Color.hpp"
#include "RGBA.hpp"
//#include "ReadMesh.hpp"

using namespace std;

#define WAK_HEADER                      0x2020

// Material
#define MAT_TAG                         0x2021
#define MAT_AMBIENT                     0x2022
#define MAT_DIFFUSE                     0x2023
#define MAT_SPECULAR            0x2024
#define MAT_SHININESS           0x2025
#define MAT_TRANSPARENCY        0x2026
#define MAT_EMMISSION           0x2027
#define MAT_LIGHTSPREAD         0x2028
#define MAT_LIGHTDIRECTION      0x2029

// End tag
#define END_TAG                         0x2060

#define MAX_TEXTURES 0x2

typedef std::string String;

class Material {
    public:
    String m_name;              // Material name

    Color m_ambient;            // Ambient colour
    Color m_diffuse;            // Diffuse colour
    Color m_specular;           // Specular colour
    float m_shininess;          // Shininess factor
    float m_transparency;               // Transparency factor
    Color m_emmission;          // Emission factor
    float m_emmissive;

    float m_lightSpread;                // Spread angle of light cone
    vector<vector<float> > m_lightDirection;    // light direction
//    friend ReadMesh(vector<Mesh>&, vector<Material>&, char*);

};

#endif
