#include "ReadMaterial.hpp"
#include "ReadMesh.hpp"
#include <string>
#include <fstream>
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <cctype>


void ReadName(FILE *fp, char *name)
{
        int nameLength=0;
        char ch, temporary[15];
        fscanf(fp,"%s",temporary);
#ifdef DEBUG
        printf("%s",temporary);
#endif
        ch = (char)fgetc(fp);
        while((ch = (char)fgetc(fp)) != '\n')
        {
               if(ch == '"'){}
               else {
                name[nameLength++] = ch;
               }
        }
        name[nameLength]=0;
#ifdef DEBUG
        printf("\t%s\n",name);
#endif
}


void ReadName_Mesh(FILE *fp, char *mesh_name)
{
        int nameLength=0;
        char ch, temporary[15];
        ch = (char)fgetc(fp);
        while((ch = (char)fgetc(fp)) != '"'){}
        while((ch = (char)fgetc(fp)) != '\n')
        {
               if(ch == '"'){}
               else {
                mesh_name[nameLength++] = ch;
               }
        }
        mesh_name[nameLength]=0;
#ifdef DEBUG
        printf("\t%s\n",mesh_name);              
#endif
}


void ReadTextureName(FILE *fp, char *tex_name)
{
        int nameLength=0;
        char ch;
        while((ch = (char)fgetc(fp)) != '"'){
                tex_name[nameLength++] = ch;
        }
        tex_name[nameLength]=0;
#ifdef DEBUG
        printf("\t%s",tex_name);              
#endif
}


int totVertices = 0;
int totTriangles = 0;
int numMesh;
int numMaterial;

void ReadMesh(vector<Mesh>& pMesh, vector<Material>& pMtl, char* filename)
{
    int numMesh, numMaterial;
    char ch;
    int k;
    char names[10], names1[10];
    printf("%s", filename);
    FILE *fp = fopen(filename, "r");
    FILE *fp1 = fopen("mesh2382","w");
    printf("Checkpoint 1 in ReadMesh\n");

    if (fp) {

              printf("Checkpoint 2 in ReadMesh\n");
              while ((ch = (char) fgetc(fp)) != '\n') {}     //ignore the header "# NCST Wak Converted from %s Wab"
                   fscanf(fp, "%s", names);
#ifdef DEBUG
                   printf("%s",names);
#endif
                   if ((k=strcmp(names,"materials")) == 0)  //keyword "materials"
                    {
                            fscanf(fp, "%d", &numMaterial);      // no. of materials used
#ifdef DEBUG
                            printf("%d\n",numMaterial);
#endif
                            ::numMaterial = numMaterial;
                    }

                   //read all the materials
                   for(int i=0; i<numMaterial; i++)
                   {
                      char name[1024], tmp[100];
		      float f;
                      char ch;
                      Material Ma_temp;

                      ReadName(fp, name);             // read the name of the material
                      Ma_temp.m_name = name;


                      while((ch = (char)fgetc(fp)) != '\n'){}
                      while((ch = (char)fgetc(fp)) != '['){}
                      fscanf(fp,"%f %f %f %f",&c.red,&c.green,&c.blue,&c.alpha);  //ambient terms
#ifdef DEBUG
                      printf("%f %f %f %f \n", c.red, c.green, c.blue, c.alpha);
#endif
                      Ma_temp.m_ambient = c;


                      while((ch = (char)fgetc(fp)) != '\n'){}
                      while((ch = (char)fgetc(fp)) != '['){}
                      fscanf(fp,"%f %f %f %f",&d.red,&d.green,&d.blue,&d.alpha);  //diffuse terms
#ifdef DEBUG
                      printf("%f %f %f %f \n", d.red, d.green, d.blue, d.alpha);
#endif
                      Ma_temp.m_diffuse = d;

                      while((ch = (char)fgetc(fp)) != '\n'){}
                      while((ch = (char)fgetc(fp)) != '['){}
                      fscanf(fp,"%f %f %f %f",&c.red,&c.green,&c.blue,&c.alpha);  //specular terms
#ifdef DEBUG
                      printf("%f %f %f %f \n", c.red, c.green, c.blue, c.alpha);
#endif
                      Ma_temp.m_specular = c;

                      while((ch = (char)fgetc(fp)) != '\n'){}
                      fscanf(fp,"%s %f",tmp,&f);                                  //shininess term
#ifdef DEBUG
                      printf("%f \n",f);
#endif
                      Ma_temp.m_shininess = f;
            
                      fscanf(fp,"%s %f",tmp,&f);                                  //transparency term
#ifdef DEBUG
                      printf("%f \n",f);
#endif
                      Ma_temp.m_transparency = f;

                      while((ch = (char)fgetc(fp)) != '\n'){}
                      while((ch = (char)fgetc(fp)) != '['){}
                      fscanf(fp,"%f %f %f %f",&e.red,&e.green,&e.blue,&e.alpha);  //emission terms
#ifdef DEBUG
                      printf("%f %f %f %f \n", e.red, e.green, e.blue, e.alpha);
#endif
                      Ma_temp.m_emmission = e;
                      Ma_temp.m_emmissive = (e.red/d.red);

                      while((ch = (char)fgetc(fp)) != '\n'){}
                      while((ch = (char)fgetc(fp)) != '\n'){}        // go to top and start reading new material

                      pMtl.push_back(Ma_temp);
           
                }


/*
              while ((ch = (char) fgetc(fp)) != '\n') {}     //ignore the header "# NCST Wak Converted from %s Wab"
                   fscanf(fp, "%s", names);
#ifdef DEBUG
              printf("%s",names);
#endif
              if ((k=strcmp(names,"materials")) == 0)  //keyword "materials"
              {
                   fscanf(fp, "%d", &numMaterial);      // no. of materials used
#ifdef DEBUG
                   printf("%d\n",numMaterial);
#endif
 //                  ::numMaterial = numMaterial;
              }
              do
              {
                 fscanf(fp,"%s",names1);
              }while((k = strcmp(names1, "meshes")) == 0);
*/

              
              while((ch = (char)fgetc(fp)) != '\n'){}

              fscanf(fp,"%s",names1);
#ifdef DEBUG
                   printf("%s\t",names1);
#endif

                   if ((k = strcmp(names1, "meshes")) == 0)  //keyword "meshes"
                    {
                            fscanf(fp, "%d", &numMesh);      // read no. of meshes used
#ifdef DEBUG
                            printf("%d\n",numMesh);
#endif
                            ::numMesh = numMesh;
                    }

               for(int i=0; i<numMesh; i++)
                   {
                   char name[1024], tmp[100], tex_name[1024], mesh_name[1024], tmp1[100];
                      int nameLength=0, z;
                      char bDoubleSided;
                      vector<float>v(3);
                      vector<float>tc(2);
                      vector<unsigned long> t(3);
		      float f;
                      Mesh Me_temp;
               
                      Me_temp.m_number = i;
                      ReadName(fp, name);                                    // read the name of the mesh
                      Me_temp.m_name = name;
                      if(i==2381 || i==2382 || i==2383)
                          fprintf(fp,"Mesh Name: %s\n",name);        //edit
                      while((ch = (char)fgetc(fp)) != '\n'){}


                      fscanf(fp,"%s",tmp);
                      if(z = strcmp(tmp,"doublesided") == 0){              //Start editing
#ifdef DEBUG
                             printf("%s\n",tmp);
#endif
                             bDoubleSided = 1;
                             Me_temp.m_bTwoSided = bDoubleSided;
                             while ((ch = (char) fgetc(fp)) != '\n') {}
                             fscanf(fp1,"%s",tmp);
                      }                                                         // End Editing
                      else{
                             bDoubleSided = 0;
                             Me_temp.m_bTwoSided = bDoubleSided;
                      }

                      if(i==2381 || i==2382 || i==2383)
                          fprintf(fp1,"Boolsided: %c\n",Me_temp.m_bTwoSided);    //edit

                      ReadName_Mesh(fp, mesh_name);                      // read the name of the material and doublesided
                      if(i==2381 || i==2382 || i==2383)
                          fprintf(fp1,"Material: %s\n",mesh_name);    //edit

                      Me_temp.m_pMaterial = NULL;
                      
                      for(int j=0; j<numMaterial; j++)
                      {
                              if(pMtl[j].m_name == mesh_name)
                              {
                                      Me_temp.m_pMaterial = &pMtl[j];
                                      break;
                              }
                      }

                     while((ch = (char)fgetc(fp)) != '\n'){}
                     //Textures

                     int numTexture;
                     fscanf(fp,"%s",tmp1);
                     if(i==2381 || i==2382 || i==2383)
                          fprintf(fp1,"%s",tmp1);    //edit

#ifdef DEBUG
                     printf("%s\t",tmp1);                     
#endif
                     fscanf(fp,"%d",&numTexture);
                     if(i==2381 || i==2382 || i==2383)
                          fprintf(fp1,"\t%d",numTexture);    //edit
#ifdef DEBUG
                     printf("%d\t",numTexture);              
#endif
                     Me_temp.m_numTextures = numTexture;
                     ch = (char)fgetc(fp);
                     ch = (char)fgetc(fp);
              
// MAJOR EDIT

                     if(numTexture == 0)
                      {
                         int j =0;
                         ReadTextureName(fp, name);                              // Texture Name
                         
                         Me_temp.m_pTexture[j] = name;
                         if(i==2381 || i==2382 || i==2383)
                          fprintf(fp1,"\t%s",name);    //edit
                         int numTexco;                                          // Number of Texture Co-ordinates
                         ch = (char)fgetc(fp);
                         fscanf(fp,"%d",&numTexco);
                         if(i==2381 || i==2382 || i==2383)
                          fprintf(fp1,"\t%d\n",numTexco);    //edit
#ifdef DEBUG
                         printf("\t%d\n",numTexco);             
#endif
                         Me_temp.m_nTextureCoords = numTexco;

                         while((ch = (char)fgetc(fp)) != '\n'){}
                         for(int k=0; k<numTexco; k++)
                         {
                             while((ch = (char)fgetc(fp)) != '\n'){}
                             while((ch = (char)fgetc(fp)) != '['){}
                             fscanf(fp,"%f %f",&tc[0],&tc[1]);
                             if(i==2381 || i==2382 || i==2383)
                                 fprintf(fp1,"%f\t  %f\n ",tc[0],tc[1]);    //edit
#ifdef DEBUG
                             printf("%f\t  %f\n ",tc[0],tc[1]);     
#endif
                             Me_temp.m_pTextureCoords[j].push_back(tc);
                         } 
                     
                      }

                     else {
                      for(int j=0; j<=numTexture; j++)
                      {
         
                         ReadTextureName(fp, tex_name);                              // Texture Name
                         Me_temp.m_pTexture[j] = tex_name;

                         int numTexco;                                          // Number of Texture Co-ordinates
                         ch = (char)fgetc(fp);
                         fscanf(fp,"%d",&numTexco);
                         if(i==2381 || i==2382 || i==2383)
                            fprintf(fp1,"\t%d\n",numTexco);    //edit
#ifdef DEBUG
                         printf("\t%d\n",numTexco);             
#endif
                         while((ch = (char)fgetc(fp)) != '\n'){}
                         for(int k=0; k<numTexco; k++)
                         {
                             while((ch = (char)fgetc(fp)) != '\n'){}
                             while((ch = (char)fgetc(fp)) != '['){}
                             fscanf(fp,"%f %f",&tc[0],&tc[1]);
                              if(i==2381 || i==2382 || i==2383)
                                fprintf(fp1,"%f\t  %f\n ",tc[0],tc[1]);   //edit
#ifdef DEBUG
                             printf("%f\t  %f\n ",tc[0],tc[1]);     
#endif
                             Me_temp.m_pTextureCoords[j].push_back(tc);
                         }

                      }
                    }
                     while((ch = (char)fgetc(fp)) != '\n'){}
                     while((ch = (char)fgetc(fp)) != '\n'){}
                     while((ch = (char)fgetc(fp)) != '\n'){}
                   
                     //Vertices

                     int numVertices;
                     fscanf(fp,"%s",tmp);
                     if(i==2381 || i==2382 || i==2383)
                                fprintf(fp1,"%s",tmp); //edit
#ifdef DEBUG
                     printf("%s",tmp);                     
#endif
                     fscanf(fp,"%d",&numVertices);                             //Number of Vertices
                     if(i==2381 || i==2382 || i==2383)
                                fprintf(fp1,"\t%d\n",numVertices);   //edit
#ifdef DEBUG
                     printf("\t%d\n",numVertices);              
#endif
                     totVertices += numVertices;
                     Me_temp.m_nVertices = numVertices;
                     while((ch = (char)fgetc(fp)) != '\n'){}
                     for(int j=0; j<numVertices; j++)
                     {
                         while((ch = (char)fgetc(fp)) != '\n'){}
                         while((ch = (char)fgetc(fp)) != '['){}
                         fscanf(fp,"%f %f %f",&v[0],&v[1],&v[2]);
                          if(i==2381 || i==2382 || i==2383)
                                fprintf(fp1,"%f\t  %f\t %f \n ",v[0],v[1], v[2]);  //edit
#ifdef DEBUG
                         printf("%f\t  %f\t %f \n ",v[0],v[1], v[2]);     
#endif
                         Me_temp.m_pVertices.push_back(v);

                     }

                     while((ch = (char)fgetc(fp)) != '\n'){}
                     while((ch = (char)fgetc(fp)) != '\n'){}
                     while((ch = (char)fgetc(fp)) != '\n'){}

                    
                    //Normals

                    int numNormals;
                    fscanf(fp,"%s",tmp);
                    if(i==2381 || i==2382 || i==2383)
                                fprintf(fp1,"%s",tmp);   //edit
#ifdef DEBUG
                    printf("%s",tmp);
#endif
                    fscanf(fp,"%d",&numNormals);                             //Number of Normals
                    if(i==2381 || i==2382 || i==2383)
                                fprintf(fp1,"\t%d\n",numNormals);   //edit
#ifdef DEBUG
                    printf("\t%d\n",numNormals);              
#endif
                    Me_temp.m_nNormals = numNormals;

                    while((ch = (char)fgetc(fp)) != '\n'){}
                    for(int j=0; j<numNormals; j++)
                    {
                         while((ch = (char)fgetc(fp)) != '\n'){}
                         while((ch = (char)fgetc(fp)) != '['){}
                         fscanf(fp,"%f %f %f",&v[0],&v[1],&v[2]);
                         if(i==2381 || i==2382 || i==2383)
                                fprintf(fp1,"%f\t  %f\t %f \n ",v[0],v[1], v[2]);  //edit
#ifdef DEBUG
                         printf("%f\t  %f\t %f \n ",v[0],v[1], v[2]);     
#endif
                         Me_temp.m_pNormals.push_back(v);
                    }
   
                    while((ch = (char)fgetc(fp)) != '\n'){}
                    while((ch = (char)fgetc(fp)) != '\n'){}
                    while((ch = (char)fgetc(fp)) != '\n'){}                    


                    //Triangles 

                    int numTriangles;

                    fscanf(fp,"%s",tmp);
                    if(i==2381 || i==2382 || i==2383)
                                fprintf(fp1,"%s",tmp);   //edit
#ifdef DEBUG
                    printf("%s",tmp);              
#endif
                    fscanf(fp,"%d",&numTriangles);                         //Number of Triangles
                    if(i==2381 || i==2382 || i==2383)
                                fprintf(fp1,"\t%d\n",numTriangles);  //edit
#ifdef DEBUG
                    printf("\t%d\n",numTriangles);        
#endif
                    totTriangles += numTriangles;
                    Me_temp.m_nTriangleList = numTriangles;
                    while((ch = (char)fgetc(fp)) != '\n'){}
                    for(int j=0; j<numTriangles; j++)
                    {
                       while((ch = (char)fgetc(fp)) != '\n'){}
                       while((ch = (char)fgetc(fp)) != '['){}
                       fscanf(fp,"%d %d %d",&t[0],&t[1],&t[2]);
                       if(i==2381 || i==2382 || i==2383)
                                fprintf(fp1,"%d\t  %d\t %d \n ",t[0],t[1], t[2]);  //edit
#ifdef DEBUG
                       printf("%d\t  %d\t %d \n ",t[0],t[1], t[2]);     
#endif
                       Me_temp.m_pTriangleList.push_back(t);
                    }
      
                    pMesh.push_back(Me_temp);

                    for(int aa=0;aa<5;aa++)
                       while((ch = (char)fgetc(fp)) != '\n'){}
//                    printf("l = 0 \t i = %d\n",i);

                             
           }
        }
        fclose(fp);
}



void Subdivide(vector<Mesh>& pMesh, vector<Material>& pMtl)
{
   int l, t1, t2, t3, numTexture, numTriangles, numVertices, numNormals, numTexco, vCount, tCount, i, j, k;

   vector<float> V1(3), V2(3), V3(3), N1(3), N2(3), N3(3);
   vector<float> U1(2), U2(2), U3(2), W1(2), W2(2), W3(2);

   vector<unsigned long> T(3);
 
     for(l=1;l<2;l++)
     {   
         for(i=0;i<numMesh;i++)
         {
             numTriangles = pMesh[i].m_nTriangleList;
             numVertices  = pMesh[i].m_nVertices;
             numNormals   = pMesh[i].m_nNormals;
             numTexco     = pMesh[i].m_nTextureCoords;
             numTexture   = pMesh[i].m_numTextures;


             vCount = 0;
             tCount = 0;
#ifdef DEBUG
             printf("numTriangles\t numVertices\t numNormals\t numTexco\t vCount\t tCount\n");
             printf("%d \t%d \t%d \t%d \t%d \t%d\n", numTriangles, numVertices, numNormals, numTexco, vCount, tCount);
#endif
             for(j=0;j<numTriangles;j++)
             {
                 for(k=0;k<3;k++)
                     T[k] = pMesh[i].m_pTriangleList[j][k];     //read vertex indices from trianglelist
                 t1 = T[0];
                 t2 = T[1];
                 t3 = T[2];
#ifdef DEBUG
                 printf("Triangle\t%d\t %d\t %d\n",t1,t2,t3);
#endif

                 for(k=0;k<3;k++)
                 {
                     V1[k] = pMesh[i].m_pVertices[t1][k];     // Get the geometric info. abt vertex and normals
                     V2[k] = pMesh[i].m_pVertices[t2][k];
                     V3[k] = pMesh[i].m_pVertices[t3][k];
		     N1[k] = pMesh[i].m_pNormals[t1][k];
		     N2[k] = pMesh[i].m_pNormals[t2][k];
		     N3[k] = pMesh[i].m_pNormals[t3][k];
                 }
/*                     k=0;
                     printf("Vertex1\t%f\t%f\t%f\n", V1[k], V1[k+1], V1[k+2]);
                     printf("Vertex2\t%f\t%f\t%f\n", V2[k], V2[k+1], V2[k+2]);
                     printf("Vertex3\t%f\t%f\t%f\n", V3[k], V3[k+1], V3[k+2]);
*/
                 for(k=0;k<2;k++)
                 {
                     U1[k] = pMesh[i].m_pTextureCoords[0][t1][k];   // Get the Texture Co-ordinates
                     U2[k] = pMesh[i].m_pTextureCoords[0][t2][k];
                     U3[k] = pMesh[i].m_pTextureCoords[0][t3][k];
                     if(numTexture != 0)
                     {
                        W1[k] = pMesh[i].m_pTextureCoords[1][t1][k];
		        W2[k] = pMesh[i].m_pTextureCoords[1][t2][k];
		        W3[k] = pMesh[i].m_pTextureCoords[1][t3][k];
                     }
                 }
                     

                     vector<float> V12(3), V13(3), V23(3), N12(3), N13(3), N23(3);
                     vector<float> U12(2), U13(2), U23(2), W12(2), W13(2), W23(2);

                     for(k=0;k<3;k++)                            //Get new vertices and Normals
                     {
                         V12[k] = (V1[k] + V2[k])/2.0;
                         V13[k] = (V1[k] + V3[k])/2.0;
			 V23[k] = (V2[k] + V3[k])/2.0;
			 N12[k] = (N1[k] + N2[k])/2.0;
			 N13[k] = (N1[k] + N3[k])/2.0;
			 N23[k] = (N2[k] + N3[k])/2.0;
                     }
/*                     k=0;
                     printf("New_Vertex1\t%f\t%f\t%f\n", V12[k], V12[k+1], V12[k+2]);
                     printf("New_Vertex2\t%f\t%f\t%f\n", V13[k], V13[k+1], V13[k+2]);
                     printf("New_Vertex3\t%f\t%f\t%f\n", V23[k], V23[k+1], V23[k+2]);
*/

                     for(k=0;k<2;k++)                          //Get new Texture Co-ordinates
                     {
                         U12[k] = (U1[k] + U2[k])/2.0;
                         U13[k] = (U1[k] + U3[k])/2.0;
                         U23[k] = (U2[k] + U3[k])/2.0;
                         if(numTexture != 0)
                         {
                            W12[k] = (W1[k] + W2[k])/2.0;
                            W13[k] = (W1[k] + W3[k])/2.0;
                            W23[k] = (W2[k] + W3[k])/2.0;
                         }
                     }

#ifdef DEBUG
                     k=0;
                     printf("Vertex1\t%f\t%f\t%f\n", V1[k], V1[k+1], V1[k+2]);
                     printf("Vertex2\t%f\t%f\t%f\n", V2[k], V2[k+1], V2[k+2]);
                     printf("Vertex3\t%f\t%f\t%f\n", V3[k], V3[k+1], V3[k+2]);
                     printf("Normal1\t%f\t%f\t%f\n", N1[k], N1[k+1], N1[k+2]);
                     printf("Normal2\t%f\t%f\t%f\n", N2[k], N2[k+1], N2[k+2]);
                     printf("Normal3\t%f\t%f\t%f\n", N3[k], N3[k+1], N3[k+2]);
                     printf("Tex1\t%f\t%f\n", U1[k], U1[k+1]);
                     printf("Tex2\t%f\t%f\n", U2[k], U2[k+1]);
                     printf("Tex3\t%f\t%f\n", U3[k], U3[k+1]);
                     printf("New_Vertex1\t%f\t%f\t%f\n", V12[k], V12[k+1], V12[k+2]);
                     printf("New_Vertex2\t%f\t%f\t%f\n", V13[k], V13[k+1], V13[k+2]);
                     printf("New_Vertex3\t%f\t%f\t%f\n", V23[k], V23[k+1], V23[k+2]);
                     printf("New_normal1\t%f\t%f\t%f\n", N12[k], N12[k+1], N12[k+2]);
                     printf("New_normal2\t%f\t%f\t%f\n", N13[k], N13[k+1], N13[k+2]);
                     printf("New_normal3\t%f\t%f\t%f\n", N23[k], N23[k+1], N23[k+2]);
                     printf("New_Tex1\t%f\t%f\n", U12[k], U12[k+1]);
                     printf("New_Tex2\t%f\t%f\n", U13[k], U13[k+1]);
                     printf("New_Tex3\t%f\t%f\n", U23[k], U23[k+1]);

#endif
                    

//                     for(k=0;k<3;k++)                               //Store normals and vertices in data structures
//                     {
                         pMesh[i].m_pVertices.push_back(V12);
                         pMesh[i].m_pVertices.push_back(V13);
                         pMesh[i].m_pVertices.push_back(V23);
//                       pMesh[i].m_pVertices[numVertices+vCount][k]   = V12[k];
//                       pMesh[i].m_pVertices[numVertices+vCount+1][k] = V13[k];
//                       pMesh[i].m_pVertices[numVertices+vCount+2][k] = V23[k];
                         pMesh[i].m_pNormals.push_back(N12);
                         pMesh[i].m_pNormals.push_back(N13);
                         pMesh[i].m_pNormals.push_back(N23);
//                       pMesh[i].m_pNormals[numNormals+vCount][k]     = N12[k];
//			 pMesh[i].m_pNormals[numNormals+vCount+1][k]   = N13[k];
//			 pMesh[i].m_pNormals[numNormals+vCount+2][k]   = N23[k];
//                     }
   
//                     for(k=0;k<2;k++)                           // Store texture-coordinates in data structures
//                     {
                         pMesh[i].m_pTextureCoords[0].push_back(U12);
                         pMesh[i].m_pTextureCoords[0].push_back(U13);
                         pMesh[i].m_pTextureCoords[0].push_back(U23);
//                       pMesh[i].m_pTextureCoords[0][numTexco+vCount][k]   = U12[k];
//                       pMesh[i].m_pTextureCoords[0][numTexco+vCount+1][k] = U13[k];
//			 pMesh[i].m_pTextureCoords[0][numTexco+vCount+2][k] = U23[k];
                         if(numTexture != 0)
                         {
                            pMesh[i].m_pTextureCoords[0].push_back(W12);
                            pMesh[i].m_pTextureCoords[0].push_back(W13);
                            pMesh[i].m_pTextureCoords[0].push_back(W23);
//			    pMesh[i].m_pTextureCoords[1][numTexco+vCount][k]   = W12[k];
//			    pMesh[i].m_pTextureCoords[1][numTexco+vCount+1][k] = W13[k];
//			    pMesh[i].m_pTextureCoords[1][numTexco+vCount+2][k] = W23[k];
                         }
//                     }


                     //Append the new triangle list to the data structure
  
                     vector<unsigned long> New_T(3);

                     New_T[0] = t1;
                     New_T[1] = numVertices + vCount;
                     New_T[2] = numVertices + vCount + 1;
                     pMesh[i].m_pTriangleList.push_back(New_T);
#ifdef DEBUG 
                     printf("New_Triangle1\t%d\t%d\t%d\n", New_T[0], New_T[1], New_T[2]);
#endif

                     New_T[0] = numVertices + vCount;
                     New_T[1] = t2;
                     New_T[2] = numVertices + vCount + 2;
                     pMesh[i].m_pTriangleList.push_back(New_T);
#ifdef DEBUG
                     printf("New_Triangle2\t%d\t%d\t%d\n", New_T[0], New_T[1], New_T[2]);
#endif

                     New_T[0] = numVertices + vCount + 1;
                     New_T[1] = numVertices + vCount + 2;
                     New_T[2] = t3;
                     pMesh[i].m_pTriangleList.push_back(New_T);
#ifdef DEBUG
                     printf("New_Triangle3\t%d\t%d\t%d\n", New_T[0], New_T[1], New_T[2]);
#endif

                     New_T[0] = numVertices + vCount;
                     New_T[1] = numVertices + vCount + 2;
                     New_T[2] = numVertices + vCount + 1;
                     pMesh[i].m_pTriangleList.push_back(New_T);
#ifdef DEBUG
                     printf("New_Triangle4\t%d\t%d\t%d\n", New_T[0], New_T[1], New_T[2]);
#endif


//                   pMesh[i].m_pTriangleList[numTriangles+tCount][0] = t1;
//                   pMesh[i].m_pTriangleList[numTriangles+tCount][1] = numVertices + vCount;
//                   pMesh[i].m_pTriangleList[numTriangles+tCount][2] = numVertices + vCount + 1;

//		     pMesh[i].m_pTriangleList[numTriangles+tCount][0] = numVertices + vCount;
//		     pMesh[i].m_pTriangleList[numTriangles+tCount][1] = t2;
//		     pMesh[i].m_pTriangleList[numTriangles+tCount][2] = numVertices + vCount + 2;

//   		     pMesh[i].m_pTriangleList[numTriangles+tCount][0] = numVertices + vCount + 1;
//		     pMesh[i].m_pTriangleList[numTriangles+tCount][1] = numVertices + vCount + 2;
//		     pMesh[i].m_pTriangleList[numTriangles+tCount][2] = t3;

//		     pMesh[i].m_pTriangleList[numTriangles+tCount][0] = numVertices + vCount;
//		     pMesh[i].m_pTriangleList[numTriangles+tCount][1] = numVertices + vCount + 2;
//		     pMesh[i].m_pTriangleList[numTriangles+tCount][2] = numVertices + vCount + 1;

                    
                     vCount = vCount + 3;
                     tCount = tCount + 4;

             }                                     //end of triangle loop 
                
             pMesh[i].m_nVertices      = pMesh[i].m_nVertices + vCount;
             pMesh[i].m_nNormals       = pMesh[i].m_nNormals + vCount;
             pMesh[i].m_nTextureCoords = pMesh[i].m_nTextureCoords + vCount;
             pMesh[i].m_nTriangleList  = pMesh[i].m_nTriangleList + tCount;
             
//             printf("l = %d\t i = %d\n",l,i);
         }                                          //end of mesh loop
     }

}





                      
