#ifndef __Mesh__
#define __Mesh__

#include <string>
#include <fstream>
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <cctype>
#include "RGBA.hpp"
#include "ReadMaterial.hpp"

using namespace std;

#define WAK_HEADER                      0x2020

// Meshes
#define MESH_TAG                        0x2040
#define VERTEX_TYPE                     0x2041
#define HINT                            0x2042
#define MESH_TEXTURE            0x2043
#define MESH_VERTICES           0x2044
#define MESH_NORMALS            0x2045
#define MESH_TRILIST            0x2046
#define MESH_DIFFUSE            0x2047
#define MESH_SPECULAR           0x2048

// End tag
#define END_TAG                         0x2060

#define MAX_TEXTURES 0x2

typedef std::string String;
typedef String Texture;


class Mesh {
    public:

    String m_name;

  //Material *m_pMaterial;
 //   Trilist triangles;
    Texture m_pTexture[MAX_TEXTURES];

    int m_number, m_nVertices, m_nNormals, m_nDiffuse, m_nSpecular;
    int m_numTextures;
    int m_nTextureCoords;

    vector<vector<float> > m_pVertices;
    vector<vector<float> > m_pNormals;
    vector<vector<float> > m_pTextureCoords[MAX_TEXTURES];
    int m_nTriangleList;
    vector<vector<unsigned long> > m_pTriangleList;
    bool m_bTwoSided;
    
  //friend void ReadMesh(vector<Mesh>&, vector<Material>&, char*);
  //friend void Subdivide(vector<Mesh>&, vector<Material>&);
};

typedef vector<Mesh> :: iterator MeshListItr;
#endif
