#ifndef _RAD_FVECT_H_
#define _RAD_FVECT_H_
#ifdef __cplusplus
extern "C" {
#endif

#ifdef  SMLFLT
#define  RREALfloat
#define  FTINY(1e-3)
#else
#define  RREALdouble
#define  FTINY(1e-6)
#endif
#define  FHUGE(1e10)

typedef RREAL  FVECT[3];

#define  VCOPY(v1,v2)((v1)[0]=(v2)[0],(v1)[1]=(v2)[1],(v1)[2]=(v2)[2])
#define  DOT(v1,v2)((v1)[0]*(v2)[0]+(v1)[1]*(v2)[1]+(v1)[2]*(v2)[2])
#define  VLEN(v)sqrt(DOT(v,v))
#define  VADD(vr,v1,v2)((vr)[0]=(v1)[0]+(v2)[0], \
(vr)[1]=(v1)[1]+(v2)[1], \
(vr)[2]=(v1)[2]+(v2)[2])
#define  VSUB(vr,v1,v2)((vr)[0]=(v1)[0]-(v2)[0], \
(vr)[1]=(v1)[1]-(v2)[1], \
(vr)[2]=(v1)[2]-(v2)[2])
#define  VSUM(vr,v1,v2,f)((vr)[0]=(v1)[0]+(f)*(v2)[0], \
(vr)[1]=(v1)[1]+(f)*(v2)[1], \
(vr)[2]=(v1)[2]+(f)*(v2)[2])
#define  VCROSS(vr,v1,v2) \
((vr)[0]=(v1)[1]*(v2)[2]-(v1)[2]*(v2)[1], \
(vr)[1]=(v1)[2]*(v2)[0]-(v1)[0]*(v2)[2], \
(vr)[2]=(v1)[0]*(v2)[1]-(v1)[1]*(v2)[0])


extern doublefdot(FVECT v1, FVECT v2);
extern doubledist2(FVECT v1, FVECT v2);
extern doubledist2line(FVECT p, FVECT ep1, FVECT ep2);
extern doubledist2lseg(FVECT p, FVECT ep1, FVECT ep2);
extern voidfcross(FVECT vres, FVECT v1, FVECT v2);
extern voidfvsum(FVECT vres, FVECT v0, FVECT v1, double f);
extern doublenormalize(FVECT v);
extern voidspinvector(FVECT vres, FVECT vorig, FVECT vnorm, double theta);


#ifdef __cplusplus
}
#endif
#endif /* _RAD_FVECT_H_ */
